Foreman - Bug #20968

invalid YAML in lookup keys can break db migrations

09/17/2017 09:15 AM - Ohad Levy

Status: New
Priority: Normal
Assignee:

Category: Templates

Target version:

Difficulty: Fixed in Releases:

Triaged: Found in Releases:

Bugzilla link: Red Hat JIRA:

Pull request:

Description

StandardError: An error has occurred, this and all later migrations canceled:

(<unknown>) : found character that cannot start any token while scanning for the next token at line

1 column 5

/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-

“load'
/home/ohad/.rvm/gems/ruby-2.4.

:in

“deserialize'
/home/ohad/.rvm/gems/ruby-2.4.
e_cast'
/home/ohad/.rvm/gems/ruby-2.4.
e'
/home/ohad/.rvm/gems/ruby-2.4.
fetch_value'
/home/ohad/.rvm/gems/ruby-2.4.

b:66:in ' _read_attribute'

/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-

b:36:in "__temp_ 4656661657c647£56716c65756"

1/gems/activerecord—
1/gems/activerecord-
1/gems/activerecord-
1/gems/activerecord—-

1/gems/activerecord—

5.0.6/1ib/active_record/coders/yaml_column.rb:24

5.0.6/1lib/active_record/type/serialized.rb:18:in

5.0.6/1lib/active_record/attribute.rb:140:in “typ

5.0.6/1lib/active_record/attribute.rb:38:in “valu

5.0.6/1lib/active_record/attribute_set.rb:44:in
5.0.6/1ib/active_record/attribute_methods/read.r

5.0.6/1ib/active_record/attribute_methods/read.r

/home/ohad/git/foreman/db/migrate/20170112175131_migrate_template_to_parameters_macros.rb:25:in b

lock (2 levels)
/home/ohad/
8:in “each'
/home/ohad/
8:in

in up'

“each'

/home/ohad/git/foreman/db/migrate/20170112175131_migrate_template_to_parameters_macros.

lock in up'

/home/ohad/git/foreman/db/migrate/20170112175131_migrate_template_to_parameters_macros.

ach'

/home/ohad/git/foreman/db/migrate/20170112175131_migrate_template_to_parameters_macros.

pV
/home/ohad/.rvm/gems/ruby—-2.4.
c_migration'
/home/ohad/.rvm/gems/ruby—-2.4.
ck (2 levels) in migrate'
/home/ohad/.rvm/gems/ruby-2.4.
ck in migrate’
/home/ohad/.rvm/gems/ruby-2.4.
ract/connection_pool.rb:398:in ‘with_connection'
/home/ohad/ .rvm/gems/ruby-2
rate'

/home/ohad/ .rvm/gems/ruby-2
rb:121:in "migrate'
/home/ohad/ .rvm/gems/ruby-2
rate'
/home/ohad/.rvm/gems/ruby-2
ock in execute_migration_in_transaction'
.rvm/gems/ruby-2.4.1/gems/activerecord-

.rvm/gems/ruby-2.4.1/gems/activerecord-

1/gems/activerecord—-
1/gems/activerecord-
1/gems/activerecord-
1/gems/activerecord—-
.4.1/gems/activerecord-
.4.1/gems/activerecord-
.4.1/gems/activerecord-

.4.1/gems/activerecord-

5.0.6/1ib/active_record/relation/delegation.rb:3
5.0.6/1ib/active_record/relation/delegation.rb:3
rb:24:in b
rb:23:in "e

rb:23:in "u

5.0.6/1lib/active_record/migration.rb:792:in "exe
5.0.6/1lib/active_record/migration.rb:773:in “blo
5.0.6/1lib/active_record/migration.rb:772:in “blo

5.0.6/1ib/active_record/connection_adapters/abst

5.0.6/1lib/active_record/migration.rb:771:in ‘mig

5.0.6/1lib/active_record/migration/compatibility.

5.0.6/1lib/active_record/migration.rb:951:in "mig

5.0.6/1ib/active_record/migration.rb:1232:in bl
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.6/1lib/active_record/migration.rb:1300:in "bl

ock in ddl_transaction'

/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.6/1ib/active_record/connection_adapters/abst
ract/database_statements.rb:232:in ‘block in transaction'
6/1lib/active_record/connection_adapters/abst

/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
ract/transaction.rb:189:in ‘within_new_transaction'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
ract/database_statements.rb:232:in "“transaction’
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
transaction'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
1 _transaction'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
ecute_migration_in_transaction'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
ock in migrate_without_lock'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
ch'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
grate_without_lock'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
grate'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
]
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
rate'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
163:in "migrate'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activerecord-5.0.
58:in "block (2 levels) in <top (required)>'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activesupport-5.0
“load'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activesupport-5.0
"block in load'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activesupport-5.0
" load_dependency'
/home/ohad/.rvm/gems/ruby-2.4.1/gems/activesupport-5.0
“load’
—e:l:in ~<main>'

Psych::SyntaxError: (<unknown>): found character that cannot start any token while scanning for

e next token at line 1 column 5

6/1lib/active_record/connection_adapters/abst

6/lib/active_record/transactions.rb:211:in

6/1lib/active_record/migration.
6/1lib/active_record/migration.
6/1lib/active_record/migration.
6/1lib/active_record/migration.
6/1lib/active_record/migration.
6/1lib/active_record/migration.
6/1lib/active_record/migration.

6/1lib/active_record/migration.

rb:

rb:

rb:

rb:

rb:

rb:

rb:

rb:

1300:

1231:14

1203:

1202:

1202:

1152:1

1006:

984:1

in

in

in

in

in

in

n

T dd

Tex

"bl

‘ea

“up

‘mig

6/1lib/active_record/tasks/database_tasks.rb:

6/1ib/active_record/railties/databases.rake:

.6/1lib/active_support/dependencies.rb:287:1in

.6/1lib/active_support/dependencies.rb:287:
.6/lib/active_support/dependencies.rb:259:

.6/1lib/active_support/dependencies.rb:287:

in

in

in

th

Related issues:
Related to Foreman - Feature #16740: Host parameters should be available in t...

Closed 09/29/2016

History

#1 - 09/17/2017 09:15 AM - Ohad Levy

- Description updated

#2 - 09/24/2017 04:37 AM - Ohad Levy

for the record, this is the record that was breaking:

idlkey|created_at |updated_at |puppetclass_id|default_valuel|path|description|validator_typelvalidator_rulelkey_t
ype|override|required|merge_overrides|avoid_duplicates|omit |type|merge_default|hidden_value
978 |allowed_hosts|[2013-01-06 08:38:52.000000[/2013-01-06 08:38:52.000000||-—= %|||||stringlf|f|f|f]||Puppetclass

LookupKey | f|f

#3 - 09/25/2017 05:39 PM - lvan Necas

- Related to Feature #16740: Host parameters should be available in templates using some macro added

#4 - 09/25/2017 05:39 PM - lvan Necas

- Category set to Templates
